Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 4670)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 4671)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+!
+! 4591 2020-07-06 15:56:08Z raasch
 ! File re-formatted to follow the PALM coding standard
 !
@@ -441,6 +444,6 @@
 !
 !--                   Check whether grid point is a natural- or urban-type surface.
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 !
 !--                   In order to avoid double-counting of surface properties, always assume that
@@ -449,14 +452,14 @@
 !--                   would be visible from above
                       IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         ghf_av(j,i) = ghf_av(j,i) + surf_lsm_h%ghf(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         ghf_av(j,i) = ghf_av(j,i) + surf_usm_h%frac(m,ind_veg_wall)  *            &
-                                                     surf_usm_h%wghf_eb(m)        +                &
-                                                     surf_usm_h%frac(m,ind_pav_green) *            &
-                                                     surf_usm_h%wghf_eb_green(m)  +                &
-                                                     surf_usm_h%frac(m,ind_wat_win)   *            &
-                                                     surf_usm_h%wghf_eb_window(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         ghf_av(j,i) = ghf_av(j,i) + surf_lsm_h(0)%ghf(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         ghf_av(j,i) = ghf_av(j,i) + surf_usm_h(0)%frac(m,ind_veg_wall)  *            &
+                                                     surf_usm_h(0)%wghf_eb(m)        +                &
+                                                     surf_usm_h(0)%frac(m,ind_pav_green) *            &
+                                                     surf_usm_h(0)%wghf_eb_green(m)  +                &
+                                                     surf_usm_h(0)%frac(m,ind_wat_win)   *            &
+                                                     surf_usm_h(0)%wghf_eb_window(m)
                       ENDIF
                    ENDDO
@@ -501,6 +504,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -508,9 +511,9 @@
                          ol_av(j,i) = ol_av(j,i) + surf_def_h(0)%ol(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         ol_av(j,i) = ol_av(j,i) + surf_lsm_h%ol(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         ol_av(j,i) = ol_av(j,i) + surf_usm_h%ol(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         ol_av(j,i) = ol_av(j,i) + surf_lsm_h(0)%ol(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         ol_av(j,i) = ol_av(j,i) + surf_usm_h(0)%ol(m)
                       ENDIF
                    ENDDO
@@ -659,6 +662,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -666,9 +669,9 @@
                          qsurf_av(j,i) = qsurf_av(j,i) + surf_def_h(0)%q_surface(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         qsurf_av(j,i) = qsurf_av(j,i) + surf_lsm_h%q_surface(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         qsurf_av(j,i) = qsurf_av(j,i) + surf_usm_h%q_surface(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         qsurf_av(j,i) = qsurf_av(j,i) + surf_lsm_h(0)%q_surface(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         qsurf_av(j,i) = qsurf_av(j,i) + surf_usm_h(0)%q_surface(m)
                       ENDIF
                    ENDDO
@@ -685,6 +688,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -693,9 +696,9 @@
                                         waterflux_output_conversion(nzb)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         qsws_av(j,i) = qsws_av(j,i) + surf_lsm_h%qsws(m) * l_v
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         qsws_av(j,i) = qsws_av(j,i) + surf_lsm_h(0)%qsws(m) * l_v
                       ELSEIF ( match_usm  .AND.  .NOT. match_lsm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         qsws_av(j,i) = qsws_av(j,i) + surf_usm_h%qsws(m) * l_v
+                         m = surf_usm_h(0)%end_index(j,i)
+                         qsws_av(j,i) = qsws_av(j,i) + surf_usm_h(0)%qsws(m) * l_v
                       ENDIF
                    ENDDO
@@ -718,18 +721,18 @@
                 DO  i = nxl, nxr
                    DO  j = nys, nyn
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         r_a_av(j,i) = r_a_av(j,i) + surf_lsm_h%r_a(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         r_a_av(j,i) = r_a_av(j,i) + surf_usm_h%frac(m,ind_veg_wall)  *            &
-                                                     surf_usm_h%r_a(m)       +                     &
-                                                     surf_usm_h%frac(m,ind_pav_green) *            &
-                                                     surf_usm_h%r_a_green(m) +                     &
-                                                     surf_usm_h%frac(m,ind_wat_win)   *            &
-                                                     surf_usm_h%r_a_window(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         r_a_av(j,i) = r_a_av(j,i) + surf_lsm_h(0)%r_a(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         r_a_av(j,i) = r_a_av(j,i) + surf_usm_h(0)%frac(m,ind_veg_wall)  *            &
+                                                     surf_usm_h(0)%r_a(m)       +                     &
+                                                     surf_usm_h(0)%frac(m,ind_pav_green) *            &
+                                                     surf_usm_h(0)%r_a_green(m) +                     &
+                                                     surf_usm_h(0)%frac(m,ind_wat_win)   *            &
+                                                     surf_usm_h(0)%r_a_window(m)
                       ENDIF
                    ENDDO
@@ -756,6 +759,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -764,9 +767,9 @@
                                        heatflux_output_conversion(nzb)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         shf_av(j,i) = shf_av(j,i) + surf_lsm_h%shf(m) * c_p
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         shf_av(j,i) = shf_av(j,i) + surf_usm_h%shf(m) * c_p
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         shf_av(j,i) = shf_av(j,i) + surf_lsm_h(0)%shf(m) * c_p
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         shf_av(j,i) = shf_av(j,i) + surf_usm_h(0)%shf(m) * c_p
                       ENDIF
                    ENDDO
@@ -789,6 +792,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -796,9 +799,9 @@
                          ssws_av(j,i) = ssws_av(j,i) + surf_def_h(0)%ssws(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         ssws_av(j,i) = ssws_av(j,i) + surf_lsm_h%ssws(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         ssws_av(j,i) = ssws_av(j,i) + surf_usm_h%ssws(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         ssws_av(j,i) = ssws_av(j,i) + surf_lsm_h(0)%ssws(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         ssws_av(j,i) = ssws_av(j,i) + surf_usm_h(0)%ssws(m)
                       ENDIF
                    ENDDO
@@ -811,6 +814,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -818,9 +821,9 @@
                          ts_av(j,i) = ts_av(j,i) + surf_def_h(0)%ts(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         ts_av(j,i) = ts_av(j,i) + surf_lsm_h%ts(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         ts_av(j,i) = ts_av(j,i) + surf_usm_h%ts(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         ts_av(j,i) = ts_av(j,i) + surf_lsm_h(0)%ts(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         ts_av(j,i) = ts_av(j,i) + surf_usm_h(0)%ts(m)
                       ENDIF
                    ENDDO
@@ -833,6 +836,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -840,9 +843,9 @@
                          tsurf_av(j,i) = tsurf_av(j,i) + surf_def_h(0)%pt_surface(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         tsurf_av(j,i) = tsurf_av(j,i) + surf_lsm_h%pt_surface(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         tsurf_av(j,i) = tsurf_av(j,i) + surf_usm_h%pt_surface(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         tsurf_av(j,i) = tsurf_av(j,i) + surf_lsm_h(0)%pt_surface(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         tsurf_av(j,i) = tsurf_av(j,i) + surf_usm_h(0)%pt_surface(m)
                       ENDIF
                    ENDDO
@@ -866,6 +869,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -873,9 +876,9 @@
                          us_av(j,i) = us_av(j,i) + surf_def_h(0)%us(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         us_av(j,i) = us_av(j,i) + surf_lsm_h%us(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         us_av(j,i) = us_av(j,i) + surf_usm_h%us(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         us_av(j,i) = us_av(j,i) + surf_lsm_h(0)%us(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         us_av(j,i) = us_av(j,i) + surf_usm_h(0)%us(m)
                       ENDIF
                    ENDDO
@@ -921,6 +924,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -928,9 +931,9 @@
                          z0_av(j,i) = z0_av(j,i) + surf_def_h(0)%z0(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         z0_av(j,i) = z0_av(j,i) + surf_lsm_h%z0(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         z0_av(j,i) = z0_av(j,i) + surf_usm_h%z0(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         z0_av(j,i) = z0_av(j,i) + surf_lsm_h(0)%z0(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         z0_av(j,i) = z0_av(j,i) + surf_usm_h(0)%z0(m)
                       ENDIF
                    ENDDO
@@ -943,6 +946,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -950,9 +953,9 @@
                          z0h_av(j,i) = z0h_av(j,i) + surf_def_h(0)%z0h(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         z0h_av(j,i) = z0h_av(j,i) + surf_lsm_h%z0h(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         z0h_av(j,i) = z0h_av(j,i) + surf_usm_h%z0h(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         z0h_av(j,i) = z0h_av(j,i) + surf_lsm_h(0)%z0h(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         z0h_av(j,i) = z0h_av(j,i) + surf_usm_h(0)%z0h(m)
                       ENDIF
                    ENDDO
@@ -965,6 +968,6 @@
                    DO  j = nys, nyn
                       match_def = surf_def_h(0)%start_index(j,i) <= surf_def_h(0)%end_index(j,i)
-                      match_lsm = surf_lsm_h%start_index(j,i) <= surf_lsm_h%end_index(j,i)
-                      match_usm = surf_usm_h%start_index(j,i) <= surf_usm_h%end_index(j,i)
+                      match_lsm = surf_lsm_h(0)%start_index(j,i) <= surf_lsm_h(0)%end_index(j,i)
+                      match_usm = surf_usm_h(0)%start_index(j,i) <= surf_usm_h(0)%end_index(j,i)
 
                       IF ( match_def )  THEN
@@ -972,9 +975,9 @@
                          z0q_av(j,i) = z0q_av(j,i) + surf_def_h(0)%z0q(m)
                       ELSEIF ( match_lsm  .AND.  .NOT. match_usm )  THEN
-                         m = surf_lsm_h%end_index(j,i)
-                         z0q_av(j,i) = z0q_av(j,i) + surf_lsm_h%z0q(m)
-                      ELSEIF ( match_usm )  THEN
-                         m = surf_usm_h%end_index(j,i)
-                         z0q_av(j,i) = z0q_av(j,i) + surf_usm_h%z0q(m)
+                         m = surf_lsm_h(0)%end_index(j,i)
+                         z0q_av(j,i) = z0q_av(j,i) + surf_lsm_h(0)%z0q(m)
+                      ELSEIF ( match_usm )  THEN
+                         m = surf_usm_h(0)%end_index(j,i)
+                         z0q_av(j,i) = z0q_av(j,i) + surf_usm_h(0)%z0q(m)
                       ENDIF
                    ENDDO
Index: palm/trunk/SOURCE/surface_coupler.f90
===================================================================
--- palm/trunk/SOURCE/surface_coupler.f90	(revision 4670)
+++ palm/trunk/SOURCE/surface_coupler.f90	(revision 4671)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! ------------------
-! 
-! 
+!
+!
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Implementation of downward facing USM and LSM surfaces
+! 
+! 4429 2020-02-27 15:24:30Z raasch
 ! bugfix: preprocessor directives rearranged for serial mode
 ! 
@@ -168,6 +171,6 @@
 !--       Send heat flux at bottom surface to the ocean. First, transfer from 
 !--       1D surface type to 2D grid.
-          CALL transfer_1D_to_2D_equal( surf_def_h(0)%shf, surf_lsm_h%shf,     &
-                                        surf_usm_h%shf )
+          CALL transfer_1D_to_2D_equal( surf_def_h(0)%shf, surf_lsm_h(0)%shf,     &
+                                        surf_usm_h(0)%shf )
           CALL MPI_SEND( surface_flux(nysg,nxlg), ngp_xy, MPI_REAL, target_id, &
                          12, comm_inter, ierr )
@@ -175,6 +178,6 @@
 !--       Send humidity flux at bottom surface to the ocean. First, transfer
 !--       from 1D surface type to 2D grid.
-          CALL transfer_1D_to_2D_equal( surf_def_h(0)%qsws, surf_lsm_h%qsws,   &
-                                        surf_usm_h%qsws )
+          CALL transfer_1D_to_2D_equal( surf_def_h(0)%qsws, surf_lsm_h(0)%qsws,   &
+                                        surf_usm_h(0)%qsws )
           IF ( humidity )  THEN
              CALL MPI_SEND( surface_flux(nysg,nxlg), ngp_xy, MPI_REAL,         &
@@ -188,6 +191,6 @@
 !--       Send the momentum flux (u) at bottom surface to the ocean. First, 
 !--       transfer from 1D surface type to 2D grid.
-          CALL transfer_1D_to_2D_equal( surf_def_h(0)%usws, surf_lsm_h%usws,   &
-                                        surf_usm_h%usws )
+          CALL transfer_1D_to_2D_equal( surf_def_h(0)%usws, surf_lsm_h(0)%usws,   &
+                                        surf_usm_h(0)%usws )
           CALL MPI_SEND( surface_flux(nysg,nxlg), ngp_xy, MPI_REAL, target_id, &
                          15, comm_inter, ierr )
@@ -195,6 +198,6 @@
 !--       Send the momentum flux (v) at bottom surface to the ocean. First, 
 !--       transfer from 1D surface type to 2D grid.
-          CALL transfer_1D_to_2D_equal( surf_def_h(0)%vsws, surf_lsm_h%vsws,   &
-                                        surf_usm_h%vsws )
+          CALL transfer_1D_to_2D_equal( surf_def_h(0)%vsws, surf_lsm_h(0)%vsws,   &
+                                        surf_usm_h(0)%vsws )
           CALL MPI_SEND( surface_flux(nysg,nxlg), ngp_xy, MPI_REAL, target_id, &
                          16, comm_inter, ierr )
@@ -218,6 +221,6 @@
 !
 !--       Transfer from 1D surface type to 2D grid.
-          CALL transfer_1D_to_2D_unequal( surf_def_h(0)%shf, surf_lsm_h%shf,   &
-                                          surf_usm_h%shf )
+          CALL transfer_1D_to_2D_unequal( surf_def_h(0)%shf, surf_lsm_h(0)%shf,   &
+                                          surf_usm_h(0)%shf )
 
           CALL MPI_REDUCE( total_2d, total_2d_a, ngp_a, MPI_REAL, MPI_SUM, 0,  &
@@ -232,6 +235,6 @@
 !--          Transfer from 1D surface type to 2D grid.
              CALL transfer_1D_to_2D_unequal( surf_def_h(0)%qsws,              &
-                                             surf_lsm_h%qsws,                 &
-                                             surf_usm_h%qsws )
+                                             surf_lsm_h(0)%qsws,                 &
+                                             surf_usm_h(0)%qsws )
 
              CALL MPI_REDUCE( total_2d, total_2d_a, ngp_a, MPI_REAL, MPI_SUM, &
@@ -255,6 +258,6 @@
 !
 !--       Transfer from 1D surface type to 2D grid.
-          CALL transfer_1D_to_2D_unequal( surf_def_h(0)%usws, surf_lsm_h%usws, &
-                                          surf_usm_h%usws )
+          CALL transfer_1D_to_2D_unequal( surf_def_h(0)%usws, surf_lsm_h(0)%usws, &
+                                          surf_usm_h(0)%usws )
           CALL MPI_REDUCE( total_2d, total_2d_a, ngp_a, MPI_REAL, MPI_SUM, 0, &
                            comm2d, ierr )
@@ -266,6 +269,6 @@
 !
 !--       Transfer from 1D surface type to 2D grid.
-          CALL transfer_1D_to_2D_unequal( surf_def_h(0)%usws, surf_lsm_h%usws, &
-                                          surf_usm_h%usws )
+          CALL transfer_1D_to_2D_unequal( surf_def_h(0)%usws, surf_lsm_h(0)%usws, &
+                                          surf_usm_h(0)%usws )
           CALL MPI_REDUCE( total_2d, total_2d_a, ngp_a, MPI_REAL, MPI_SUM, 0, &
                            comm2d, ierr )
@@ -473,6 +476,6 @@
 
             REAL(wp), DIMENSION(1:surf_def_h(0)%ns) ::  def_1d !< 1D surface flux, default surfaces
-            REAL(wp), DIMENSION(1:surf_lsm_h%ns)    ::  lsm_1d !< 1D surface flux, natural surfaces
-            REAL(wp), DIMENSION(1:surf_usm_h%ns)    ::  usm_1d !< 1D surface flux, urban surfaces
+            REAL(wp), DIMENSION(1:surf_lsm_h(0)%ns) ::  lsm_1d !< 1D surface flux, natural surfaces
+            REAL(wp), DIMENSION(1:surf_usm_h(0)%ns) ::  usm_1d !< 1D surface flux, urban surfaces
 !
 !--         Transfer surface flux at default surfaces to 2D grid 
@@ -486,6 +489,6 @@
             IF ( land_surface )  THEN 
                DO  m = 1, SIZE(lsm_1d)
-                  i = surf_lsm_h%i(m)
-                  j = surf_lsm_h%j(m)
+                  i = surf_lsm_h(0)%i(m)
+                  j = surf_lsm_h(0)%j(m)
                   surface_flux(j,i) = lsm_1d(m)
                ENDDO
@@ -495,6 +498,6 @@
             IF ( urban_surface )  THEN 
                DO  m = 1, SIZE(usm_1d)
-                  i = surf_usm_h%i(m)
-                  j = surf_usm_h%j(m)
+                  i = surf_usm_h(0)%i(m)
+                  j = surf_usm_h(0)%j(m)
                   surface_flux(j,i) = usm_1d(m)
                ENDDO
@@ -541,6 +544,6 @@
 
             REAL(wp), DIMENSION(1:surf_def_h(0)%ns) ::  def_1d !< 1D surface flux, default surfaces
-            REAL(wp), DIMENSION(1:surf_lsm_h%ns)    ::  lsm_1d !< 1D surface flux, natural surfaces
-            REAL(wp), DIMENSION(1:surf_usm_h%ns)    ::  usm_1d !< 1D surface flux, urban surfaces
+            REAL(wp), DIMENSION(1:surf_lsm_h(0)%ns)    ::  lsm_1d !< 1D surface flux, natural surfaces
+            REAL(wp), DIMENSION(1:surf_usm_h(0)%ns)    ::  usm_1d !< 1D surface flux, urban surfaces
 !
 !--         Transfer surface flux at default surfaces to 2D grid. Transfer no
@@ -559,6 +562,6 @@
             IF ( land_surface )  THEN 
                DO  m = 1, SIZE(lsm_1d)
-                  i = surf_lsm_h%i(m)
-                  j = surf_lsm_h%j(m)
+                  i = surf_lsm_h(0)%i(m)
+                  j = surf_lsm_h(0)%j(m)
 
                   IF ( i >= nxl  .AND.  i <= nxr  .AND.                        &
@@ -572,6 +575,6 @@
             IF ( urban_surface )  THEN 
                DO  m = 1, SIZE(usm_1d)
-                  i = surf_usm_h%i(m)
-                  j = surf_usm_h%j(m)
+                  i = surf_usm_h(0)%i(m)
+                  j = surf_usm_h(0)%j(m)
 
                   IF ( i >= nxl  .AND.  i <= nxr  .AND.                        &
